(c-declare "
#include \"/usr/include/X11/Xlib.h\"
#include \"/usr/include/X11/Xutil.h\"
#include \"/usr/include/assert.h\"
")

(c-define-type XEvent (struct "_Xevent"))
(c-define-type char* (pointer char))

;; creates the functions which allocates the type

(define-macro (make-maker name)
  `(define ,(string->symbol (string-append "%make-" name))
     (let ((%new
	    (c-lambda
	     ()
	     (pointer ,(string->symbol name))
	     ,(string-append
	       " ___result = (" name "*)malloc (sizeof(" name ")); assert(___result);"))))
     (lambda ()
       (let* ((obj (%new)))
	 (make-will obj (lambda () (display "FREE") (%free obj)))
	 obj)))))

(make-maker "XEvent")
(make-maker "int")
(make-maker "char*")

(define char*-set!
  (c-lambda ((pointer (pointer char)) char-string) void
"
   *___arg1 = ___arg2;
"))

(define %XEvent-type
  (c-lambda ((pointer XEvent)) int
"
   ___result = ___arg1->type;
"))

(define BlackPixel
  (c-lambda ((pointer void) int) int
"
  ___result = BlackPixel(___arg1, ___arg2);
"))

(define WhitePixel
  (c-lambda ((pointer void) int) int
"
  ___result = WhitePixel(___arg1, ___arg2);
"))
	    
(define %XEvent-xexpose-count
  (c-lambda ((pointer XEvent)) int
"
   ___result = ___arg1->xexpose.count;
"))

(define %XEvent-xconfigure-width
  (c-lambda ((pointer XEvent)) int
"
   ___result = ___arg1->xconfigure.width;
"))

(define %XEvent-xconfigure-height
  (c-lambda ((pointer XEvent)) int
"
   ___result = ___arg1->xconfigure.height;
"))

(define %free (c-lambda ((pointer void)) void "free"))