/* A gambit backend test file. */

/* some simple macros */

#define X1 1
#define X2 2
#define MSG "Hello, world"

/* this will be unhandled for now. Any macro which takes an argument
   is going to be very difficult to turn into something useful in
   scheme.  After all it could, and usually does, represent some
   complicated C expression.*/

#define SQR(x) (x * x)

typedef int int_t;
typedef int_t *ptr_int_t;

/* if nothing is declared with f32, i.e. is is unreferenced, then we
   will not see a c-define-type for it. */

typedef float *f32;
typedef double f64;

/* enums */

typedef enum { ONE = 1, TWO = 2, THREE = 3 } numbers;
enum foo { BAR, BAZ , BAT };

/* now some struct's with and without typedefs. */

typedef struct {
  double real;
  double imag;
} complex;

struct polar {
  double mag;
  double ang;
};

/* function declarations */

extern f64 x(struct polar *z);

extern f64 y(struct polar *z);

extern void print_polar(char *s, struct polar *z);

/* case is preserved in the names */

extern f64 Mag(complex *z);

extern char enum_char(numbers x);

#if 0
int times2(int);
int (*ptr_times2)(int);
int func(int (*)(int), int);
#endif

/* Global variable declarations - accessors will be defined for
   these. */

extern int_t var_int;

extern ptr_int_t var_ptr_int;

extern complex var_complex;

/* $Id: code.h,v 1.2 2001/02/07 07:49:12 briand Exp $ */
