;; a test file which tests the contrived ffi example

(load "example.o1")

(define display-line
  (lambda args
    (for-each
     (lambda (arg)
       (if (procedure? arg)
	   (arg)
	   (display arg)))
     args)))

(define pi 3.14159)

(define to-radians
  (lambda (deg)
    (* pi (/ deg 180.0))))

(define z1 (%make-polar))
(%polar-mag-set! z1 1.0)
(%polar-ang-set! z1 (to-radians 45.0))

(display-line "x : " (%x z1) "\n")
(display-line "y : " (%y z1) "\n")

;; test structure accessors

(%polar-mag-set! z1 0.5)
(%polar-ang-set! z1 (to-radians 45.0))

(display-line "z1 mag : " (%polar-mag z1) "\n")
(display-line "z1 ang : " (%polar-ang z1) "\n")

;; DANGER DANGER Extremely unsafe procedure - for example and test
;; purposes ONLY.

(%print-polar "POLAR: %.6lf < %.6lf\n" z1)

(define z2 (%make-complex))
(%complex-real-set! z2 1.0)
(%complex-imag-set! z2 1.0)

(display-line "mag : " (%Mag z2) "\n")

;; test structure accessors

(%complex-real-set! z2 3.0)
(%complex-imag-set! z2 2.0)

(display-line "complex real : " (%complex-real z2) "\n")
(display-line "complex imag : " (%complex-imag z2) "\n")

;; display macros

(display-line "X1: " X1 "\n")
(display-line "X2: " X2 "\n")
(display-line "MSG: " MSG "\n")

;; returns characters

(define write-enum
  (lambda (msg enum)
    (display-line msg (lambda () (write (%enum-char enum))) "\n" )))

(write-enum "ONE : " ONE)
(write-enum "TWO : " TWO)
(write-enum "THREE : " THREE)

;; set and display global variables

(var-int-set! 33)

(display-line "var-int : " (var-int) "\n")

(cond
(#f
 (display-line "times2 4 : " (%func %times2 4) "\n")
 (display-line "times2 5 : " (%func %times2 5) "\n")
))

;; $Id: code.scm,v 1.2 2001/02/07 07:49:12 briand Exp $
