;; WARNING: Variable 'var_complex' is type 'struct' or 'union' 
;;          which cannot be returned from a c-lambda.

(c-declare
"
#include \"code.h\"
#include <assert.h>")
(define %free (c-lambda ((pointer void)) void "free"))
;;----- C MACROS -----

(define MSG "\"Hello, world\"")

(define X2 2)

(define X1 1)


;;----- ENUMS -----

(define ONE 1)

(define TWO 2)

(define THREE 3)

(define BAR 0)

(define BAZ 1)

(define BAT 2)


;;----- TYPE DEFINITIONS -----

(c-define-type int_t int)

(c-define-type ptr_int_t (pointer int))

(c-define-type f64 double)

(c-define-type numbers int)

(c-define-type complex (struct "complex"))


;;----- GLOBAL VARIABLES -----

(define var-int-set!
  (c-lambda (int_t) void " extern int_t var_int; var_int = ___arg1;"))

(define var-int
  (c-lambda () int_t " extern int_t var_int; ___result = var_int;"))

(define var-ptr-int-set!
  (c-lambda
    (ptr_int_t)
    void
    " extern ptr_int_t var_ptr_int; var_ptr_int = ___arg1;"))

(define var-ptr-int
  (c-lambda
    ()
    ptr_int_t
    " extern ptr_int_t var_ptr_int; ___result = var_ptr_int;"))

(define var-complex #f)


;;----- STRUCTURE ACCESSORS -----

(define %make-complex
  (let ((%new (c-lambda
                ()
                (pointer complex)
                " ___result = (complex*)malloc (sizeof(complex));assert(___result);")))
    (lambda ()
      (let* ((obj (%new)))
        (make-will obj (lambda () (display "FREE") (%free obj)))
        obj))))

(define %complex-real
  (c-lambda ((pointer complex)) double " ___result = ___arg1->real;"))

(define %complex-real-set!
  (c-lambda ((pointer complex) double) void " ___arg1->real = ___arg2;"))

(define %complex-imag
  (c-lambda ((pointer complex)) double " ___result = ___arg1->imag;"))

(define %complex-imag-set!
  (c-lambda ((pointer complex) double) void " ___arg1->imag = ___arg2;"))

(define %make-polar
  (let ((%new (c-lambda
                ()
                (pointer (struct "polar"))
                " ___result = (struct polar *)malloc (sizeof(struct polar ));assert(___result);")))
    (lambda ()
      (let* ((obj (%new)))
        (make-will obj (lambda () (display "FREE") (%free obj)))
        obj))))

(define %polar-mag
  (c-lambda ((pointer (struct "polar"))) double " ___result = ___arg1->mag;"))

(define %polar-mag-set!
  (c-lambda
    ((pointer (struct "polar")) double)
    void
    " ___arg1->mag = ___arg2;"))

(define %polar-ang
  (c-lambda ((pointer (struct "polar"))) double " ___result = ___arg1->ang;"))

(define %polar-ang-set!
  (c-lambda
    ((pointer (struct "polar")) double)
    void
    " ___arg1->ang = ___arg2;"))


;;----- FUNCTIONS -----

(define %x (c-lambda ((pointer (struct "polar"))) f64 "x"))

(define %y (c-lambda ((pointer (struct "polar"))) f64 "y"))

(define %print-polar
  (c-lambda (char-string (pointer (struct "polar"))) void "print_polar"))

(define %Mag (c-lambda ((pointer complex)) f64 "Mag"))

(define %enum-char (c-lambda (numbers) char "enum_char"))

